#include "B4RDefines.h"

namespace B4R
{
       B4RFlowSensor* B4RFlowSensor::instance = NULL;

//class FlowSensor
    void B4RFlowSensor::Initialize(uint16_t type,byte pin)
    {
       flow = new (backend) FlowSensor(type, pin);
    };

    void B4RFlowSensor::begin(bool pullup, SubVoidVoid CountSub)
    {
       instance = this; 
       this->CountSub = CountSub;      
       flow->begin(instance->CountSub, pullup);  
    };

// if not (ESP8266) or (ESP32)
    void B4RFlowSensor::count()
    {
       flow->count();
    };

    void B4RFlowSensor::read(int32_t calibration)
    {
       flow->read(calibration);
    };

    void B4RFlowSensor::setType(uint16_t type)
    {
       flow->setType(type);
    };

    void B4RFlowSensor::setPin(byte pin)
    {
       flow->setPin(pin);
    };

    uint32_t B4RFlowSensor::getPulse()
    {
       return flow->getPulse();
    };

    float B4RFlowSensor::getFlowRate_h()
    {
       return flow->getFlowRate_h();
    };

    float B4RFlowSensor::getFlowRate_m()
    {
       return flow->getFlowRate_m();
    };

    float B4RFlowSensor::getFlowRate_s()
    {
       return flow->getFlowRate_s();
    };

    float B4RFlowSensor::getVolume()
    {
       return flow->getVolume();
    };

    void B4RFlowSensor::resetPulse()
    {
       flow->resetPulse();
    };

    void B4RFlowSensor::resetVolume()
    {
       flow->resetVolume();
    };

// case ESP8266 or ESP32
   void IRAM_ATTR B4RFlowSensor::count_esp()
  {
     flow->count();
  };  


  }
     