#pragma once
#include "B4RDefines.h"
#include "FlowSensor.h"

    //~Event: CountSub()
    //~Version: 1 
    //~Author - 
    //~Libray from Arduino https://github.com/hafidhh/FlowSensor-Arduino


namespace B4R {
//class FlowSensor
    //~shortname:FlowSensor
    class B4RFlowSensor
    {
        private:
            uint8_t backend[sizeof(FlowSensor)];
            FlowSensor* flow;
            static B4RFlowSensor* instance;
            SubVoidVoid CountSub;

        public: 
// Construct a new FlowSensor::FlowSensor object
// param type Sensor Type
// param pin Interrupt Pin        
            void Initialize(uint16_t type,byte pin);
// sensor begin
// param userFunc = function in B4R 
// param pullup default value is fasle (0), if you have external pull up you can set to true (1)                     
            void begin(bool pullup, SubVoidVoid CountSub);
// count pulse             
// count used if not (ESP8266) or (ESP32)           
            void count();
// read sensor, get value
// calibration Calibration pulse/liter            
// by default calibration = 0            
            void read(int32_t calibration);
// setType, change type
// param type = FlowSensor Type            
            void setType(uint16_t type);
// setPin, change pin
// param pin            
            void setPin(byte pin);
// get total pulse
// return unsigned long  _totalpulse
            uint32_t getPulse();
// get value flowrate/minute (L/h)
// return float flow rate / hour            
            float getFlowRate_h();
// get value flowrate/minute (L/m)
// return float flow rate / minute           
            float getFlowRate_m();
// get value flowrate/second (L/s)
// return float flow rate / second            
            float getFlowRate_s();
// get Volume value   
// return float volume         
            float getVolume();
// Reset pulse count            
            void resetPulse();
// reset Volume            
            void resetVolume();
// count pulse             
// count only for (ESP8266) and (ESP32)            
            void IRAM_ATTR count_esp();
    };
}
